import { world, system, BlockPermutation } from '@minecraft/server';
const strongLightEmitter = ['minecraft:torch', 'minecraft:redstone_block', 'minecraft:sea_lantern', 'minecraft:lantern', 'minecraft:lit_pumpkin', 'minecraft:beacon', 'minecraft:campfire', 'minecraft:verdant_froglight', 'minecraft:pearlescent_froglight', 'minecraft:ochre_froglight', 'minecraft:glowstone', 'minecraft:shroomlight', 'minecraft:end_rod'];
const mediumLightEmitter = ['minecraft:deepslate_redstone_ore', 'minecraft:redstone_ore', 'minecraft:redstone_torch', 'minecraft:enchanting_table', 'minecraft:soul_torch', 'minecraft:soul_campfire', 'minecraft:soul_lantern','minecraft:amethyst_block', 'minecraft:nether_star'];
const weakLightEmitter = ['minecraft:ender_chest', 'minecraft:glow_lichen', 'minecraft:magma', 'minecraft:glowstone_dust', 'minecraft:amethyst_shard', 'minecraft:glow_frame', 'minecraft:sea_pickle', 'minecraft:glow_ink_sac', 'minecraft:glow_berries', 'minecraft:redstone'];

system.runInterval(
    () => {
        world.getAllPlayers().forEach(
            (player) => {
                let lightLocation1 = {x:player.location.x-1, y:player.location.y+1, z:player.location.z+1};
                let lightLocation2 = {x:player.location.x+1, y:player.location.y+1, z:player.location.z-1};
                let removeRegion1 = {x: player.location.x+3, y: player.location.y+4, z: player.location.z+3};
                let removeRegion2 = {x: player.location.x-3, y: player.location.y-1, z: player.location.z-3};
                let holdItem = player.getComponent("minecraft:inventory")?.container?.getItem(player?.selectedSlot)?.typeId;
                player.dimension.fillBlocks(removeRegion1, removeRegion2, BlockPermutation.resolve("minecraft:air"), {matchingBlock: BlockPermutation.resolve("minecraft:light_block", { block_light_level: 15 })});
                player.dimension.fillBlocks(removeRegion1, removeRegion2, BlockPermutation.resolve("minecraft:air"), {matchingBlock: BlockPermutation.resolve("minecraft:light_block", { block_light_level: 12 })});
                player.dimension.fillBlocks(removeRegion1, removeRegion2, BlockPermutation.resolve("minecraft:air"), {matchingBlock: BlockPermutation.resolve("minecraft:light_block", { block_light_level: 8 })});
                //if (holdItem) {player.onScreenDisplay.setActionBar(`Hold Item: ${holdItem}`)};
                if (strongLightEmitter.includes(holdItem)) {
                    player.dimension.fillBlocks(lightLocation1, lightLocation2, BlockPermutation.resolve("minecraft:light_block", { block_light_level: 15 }), {matchingBlock: BlockPermutation.resolve("minecraft:air")});
                } else if(mediumLightEmitter.includes(holdItem)) {
                    player.dimension.fillBlocks(lightLocation1, lightLocation2, BlockPermutation.resolve("minecraft:light_block", { block_light_level: 12 }), {matchingBlock: BlockPermutation.resolve("minecraft:air")});
                } else if(weakLightEmitter.includes(holdItem)) {
                    player.dimension.fillBlocks(lightLocation1, lightLocation2, BlockPermutation.resolve("minecraft:light_block", { block_light_level: 8 }), {matchingBlock: BlockPermutation.resolve("minecraft:air")});
                }
            },
        );
    },
);
